// Boost.Range library
//
//  Copyright Akira Takahashi 2010. Use, modification and
//  distribution is subject to the Boost Software License, Version
//  1.0. (See accompanying file LICENSE_1_0.txt or copy at
//  http://www.boost.org/LICENSE_1_0.txt)
//
// For more information, see http://www.boost.org/libs/range/
//

#ifndef BOOST_RANGE_ADAPTOR_IDENTITIES_HPP
#define BOOST_RANGE_ADAPTOR_IDENTITIES_HPP

#include <boost/range/iterator_range.hpp>

namespace boost
{
    namespace range_detail
    {
        struct identities_forwarder {};

        template< class InputRng >
        inline iterator_range< typename range_iterator<InputRng>::type >
        operator|( InputRng& r, identities_forwarder )
        {
            return make_iterator_range( r );
        }

        template< class InputRng >
        inline iterator_range< typename range_iterator<const InputRng>::type >
        operator|( const InputRng& r, identities_forwarder )
        {
            return make_iterator_range( r );
        }

    } // namespace boost::range_detail

    namespace adaptors
    {
        namespace
        {
            const range_detail::identities_forwarder
                    identities = range_detail::identities_forwarder();
        }
    } // namespace boost::adaptors

} // namespace boost

#endif
